/**
 * This is an overlay class that positions itself to any element in the DOM
 * @author Judicael Briand
 * @created Thu 15 Jul 2010 09:36:35 AM EDT 
 * @modified Sun 25 Jul 2010 04:22:46 Eastern Daylight Time 
 * Copyright (c) 2010 Judicael Briand, MIT Style License
 */
var Qoverlay = new Class({
	Implements:[Options, Events],
	
	options:{
		/**
		 * the opacity of the overlay
		 */
		opacity:0.6,
		/**
		 * the color of the overlay
		 */
		color:"#000",
		/**
		 * the zindex on show
		 */
		index:456
		/*
		$onclick
		$onshow
		$onhide
		$onresize
		*/
	},
		
	initialize: function(element, options){
		this.setOptions(options); this.index=this.options.index;
		//then we set the element
		this.element=$(element);
		//then we set the size of the element
		this.overlay = new Element('div', {
			styles:{
				backgroundColor:this.options.color,
				opacity:this.options.opacity,
				position:'absolute',
				opacity:0
			},
			
			events:{
				click:function(){
					this.fireEvent('click', this.overlay);
				}.bind(this)
			}
		});
		//then we add it to the body
		$(document.body).grab(this.overlay); this.resize();
		//then we add the window event
		window.addEvent('resize', function(){
			this.resize();
		}.bind(this));
	}.protect(),
	
	resize : function(){
		var resize = function(){
			var coor=this.element.getCoordinates(); var scr=this.element.getScrollSize(); h=scr.y-coor.height;
			this.overlay.setStyles({
					width:coor.width,
					height:coor.height+h,
					left:coor.left,
					top:coor.top,
					zIndex:this.zindex
			});
			this.fireEvent('resize', this.overlay)
		}.bind(this);
		resize();
	},
	
	/**
	 * this shows the overlay and fires the onshow event
	 */
	show: function(){
		this.overlay.fade(this.options.opacity);
		this.fireEvent('show', this.overlay);
	},
	/**
	 * this hides the overlay and fires the onhide event
	 */
	hide: function(){
		this.overlay.fade(0);
		this.fireEvent('hide', this.overlay);
	},
	/**
	 * this returns the zindex onshow
	 * @return the zindex
	 */
	getz: function(){
		return this.index;
	}
});
