/**
 * This does a progress bar
 * @author briand
 */
var Qprogress=new Class({
	
	Implements:[Options, Events],
	
	options:{
		/* $onstart, $onend */
		/**
		 * the width of the holder of the progress bar
		 */
		width:350,
		/**
		 * the initial percentage of the progress, ranges from 0 to 100
		 */
		init:62,
		/**
		 * the height of the progress bar, the height is in px
		 */
		height:25,
		/**
		 * the speed of the progress bar
		 */
		speed:1000,
		/**
		 * if to display the text
		 */
		display:true
	},
	/**
	 * This initializes the class
	 * @param {Object} element is the element to inject into
	 * @param {Object} options is the options 
	 */
	initialize: function(element, options){
		this.setOptions(options);
		this.element = $(element);
		//then we set the percentage
		this.perc=0;
		//we create our holder
		this.holder = new Element('div',{
			styles:{
				height:this.options.height,
				width:this.options.width
			},
			'class':'qprogress'
		});
		this.holder.inject(this.element);
		
		pt=this.holder.getStyle('paddingTop').toInt(); pr=this.holder.getStyle('paddingRight').toInt();
		this.options.width=this.options.width-pr;
		//then the bar
		this.bar = new Element('div',{
			styles:{
				height:this.options.height-pt,
				width:0,
				display:'inline-block',
				padding:0
			},
			tween:{
				duration:this.options.speed,
				link:'cancel'
			},
			'class':'qbar'
		});
		this.holder.adopt(this.bar); 
		
		this.move(this.options.init);
	},
	
	/**
	 * this moves the progress bar
	 * @param {Object} to is the percentage
	 */
	move: function(to){
		w=to*this.options.width/100;
		if (this.options.display && !Browser.Engine.trident) {
			var percentage = function(){
				per = (this.bar.getStyle('width').toInt() / this.options.width) * 100;
				this.bar.set('html', Math.round(per) + '%');
			}
			//we set the periodical
			p = Math.abs(this.bar.getStyle('width').toInt() - w) / this.options.speed;
			per = percentage.periodical(p, this);
			
			chain = new Chain();
			chain.chain(
				function(){this.bar.tween('width', w)}.bind(this), 
				function(){per = $clear(per)}
			);
			chain.callChain();
		}else{
			this.bar.tween('width', w);
			if(this.options.display){this.bar.set('html', to+'%')}
		}
	}
});
